﻿using System;
using System.Linq;
using Telerik.Windows;
using System.Data.SqlClient;
using System.Data;
using System.Collections.Generic;

namespace UploadSaveIntoDataBaseExample.Web
{
    /// <summary>
    /// Summary description for SampleUploadHandler
    /// </summary>
    /// 
    public class SampleUploadHandler : RadUploadHandler
    {
        private static byte[] fileByteArray;
        private static int index;
        int FileID = 0;
        bool Success = false;

        public override bool SaveChunkData(string filePath, long position, byte[] buffer, int contentLength, out int savedBytes)
        {
            savedBytes = 0;
            if (this.IsNewFileRequest())
            {
                index = 0;
                fileByteArray = new byte[8000000];
            }
            if (this.IsFinalFileRequest())
            {
                buffer.CopyTo(fileByteArray, index);
                index += buffer.Length;

                string UserID = this.GetQueryParameter("UserID");
                string connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["FilesDataBaseConnectionString"].ConnectionString;

                using (SqlConnection conn = new SqlConnection(connectionString))
                {
                    string cmdText = "INSERT INTO FileData(FileData, FileName, UserID) VALUES(@FileData, @FileName, @UserID)  SET @Identity = SCOPE_IDENTITY()";
                    SqlCommand cmd = new SqlCommand(cmdText, conn);

                    SqlParameter identityParam = new SqlParameter("@Identity", SqlDbType.Int, 0, "FileID");
                    identityParam.Direction = ParameterDirection.Output;

                    cmd.Parameters.AddWithValue("FileData", fileByteArray);
                    cmd.Parameters.AddWithValue("FileName", this.GetFileName());
                    cmd.Parameters.AddWithValue("UserID", UserID);

                    cmd.Parameters.Add(identityParam);

                    conn.Open();

                    //checking whether the operation is successfull
                    Success = (cmd.ExecuteNonQuery() != 0);

                    FileID = (int)identityParam.Value;
                }
                return Success;
            }
            else
            {
                buffer.CopyTo(fileByteArray, index);
                index += buffer.Length;
                return true;
            }
        }

        public override Dictionary<string, object> GetAssociatedData()
        {
            Dictionary<string, object> associatedData = base.GetAssociatedData();
            if (this.IsFinalFileRequest())
            {
                associatedData.Add("FileID", FileID.ToString());
                associatedData.Add("Success", Success.ToString());

            }
            return associatedData;
        }
    }
}