﻿using System;
using System.Linq;
using System.Web;
using System.Data.SqlClient;
using System.Data;

namespace UploadSaveIntoDataBaseExample.Web
{
	/// <summary>
	/// Summary description for StreamFile
	/// </summary>
	public class StreamFile : IHttpHandler
	{

		public void ProcessRequest(HttpContext context)
		{
			int id = 1;
			bool isNumber = int.TryParse(context.Request.QueryString["FileID"], out id);
			
			if (!isNumber)
			{
			    context.Response.End();
			}

			byte[] fileData = GetFile(id);

			context.Response.ContentType = "image/jpeg";
			context.Response.BinaryWrite(fileData);
			context.Response.Flush();
		}

		public bool IsReusable
		{
			get
			{
				return false;
			}
		}
		private byte[] GetFile(int id)
		{
			string connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["FilesDataBaseConnectionString"].ConnectionString;

			using (SqlConnection conn = new SqlConnection(connectionString))
			{
				string cmdText = "SELECT FileData FROM FileData WHERE FileID = @FileID;";

				SqlCommand cmd = new SqlCommand(cmdText, conn);
				SqlParameter idParam = new SqlParameter("@FileID", SqlDbType.Int);
				idParam.Value = id;

				cmd.Parameters.Add(idParam);
				conn.Open();

				using (SqlDataReader reader = cmd.ExecuteReader())
				{
					if (reader.Read())
					{
						byte[] fileData = (byte[])reader["FileData"];
						return fileData;
					}
					else
					{
						throw new ArgumentException("Invalid ID");
					}
				}
			}
		}

	}
}