﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;

namespace UploadSaveIntoDataBaseExample
{
	public partial class MainPage : UserControl
	{
		int UserID = 0;

		public MainPage()
		{
			InitializeComponent();
		}

		private void radUpload_FileUploadStarting(object sender, Telerik.Windows.Controls.FileUploadStartingEventArgs e)
		{
            UserID += 2;
            e.FileParameters.Add("UserID", UserID);
		}

		private void radUpload_FileUploaded(object sender, Telerik.Windows.Controls.FileUploadedEventArgs e)
		{
            Dictionary<string, object> customData = e.HandlerData.CustomData;
            int index = Int16.Parse(customData.Values.FirstOrDefault().ToString());

            StackPanel panel = new StackPanel() { Orientation = Orientation.Horizontal };

            CheckBox chBox = new CheckBox() { IsChecked = customData.Values.ElementAt(1).ToString() == "True" };
            panel.Children.Add(chBox);

            TextBlock fileIDTextBlock = new TextBlock();
            fileIDTextBlock.Text = "FileID: " + index.ToString();
            fileIDTextBlock.HorizontalAlignment = System.Windows.HorizontalAlignment.Center;
            fileIDTextBlock.FontWeight = FontWeights.Bold;
            panel.Children.Add(fileIDTextBlock);


            Image img = new Image();
            img.HorizontalAlignment = System.Windows.HorizontalAlignment.Center;
            img.VerticalAlignment = System.Windows.VerticalAlignment.Top;
            img.Width = 100;
            img.Height = 100;
            Uri uri = new Uri(String.Format("http://localhost:33403/StreamFile.ashx?FileID={0}", index), UriKind.RelativeOrAbsolute);
            img.Source = new BitmapImage(uri);
            panel.Children.Add(img);

            uploadedFiles.Items.Add(panel);
		}

	}
}
